﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TSP
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            List<Ort> orte = new List<Ort>();
            for (int i = 0; i < 50; i++)
            {
                orte.Add(new Ort());
            }

            List<Tour> touren = new List<Tour>();
            for (int i = 0; i < 300; i++)
            {
                touren.Add(new Tour(orte));
            }

            Random zufall = new Random();

            for (int j = 0; j < 5000; j++)
            {
                touren = touren.OrderBy(x => x.berechneGesamtstrecke()).ToList();
                // Die schlechtesten 20% sterben ab.
                // Diese Plätze füllen mit Mutationen von vorhandenen.
                for (int i = 0; i < touren.Count / 5; i++)
                {
                    touren[touren.Count - 1 - i] = touren[zufall.Next(touren.Count * 4 / 5)].Mutiere();
                }    
          
                // TO DO: Rekombination
            }

            zeichenfläche.Children.Clear();

            foreach (var t in touren)
            {
                t.Zeichne(zeichenfläche, false);
            }

            touren.OrderBy(x => x.berechneGesamtstrecke()).First().Zeichne(zeichenfläche, true);
        }
    }
}
